CC = gcc
GLADECC = lablgladecc

CFLAGS=`gtk-config --cflags`
MLFLAGS = -w s -labels -g
#ifdef DEBUG
# MLFLAGS = $(MLFLAGS) -g
# CFLAGS  = $(CFLAGS) -g
#endif

# Quick hack to find where OCAML libs are installed
OCAML_PATH=$(shell dirname `dirname \`which ocaml\``)

PXP_FLAGS = -package "pxp str" -custom -predicates pxp_without_utf8
GTK_FLAGS = -I $(OCAML_PATH)/lib/ocaml/lablgtk/
GTKLIBS=-ccopt -L/usr/lib -ccopt -L/usr/X11R6/lib -cclib -lgtk \
	-cclib -lgdk -ccopt -rdynamic -cclib -lgmodule -cclib \
	-lglib -cclib -ldl -cclib -lXi -cclib -lXext -cclib -lX11 \
	-cclib -lm  -cclib -lglade
GTK_OBJS  = -I $(OCAML_PATH)/lib/ocaml/lablgtk  lablgtk.cma gtkInit.cmo \
	$(GTKLIBS)

#CAMLC   = ocamlfind ocamlc
#CAMLOPT = ocamlfind ocamlopt
CAMLC = ocamlfind ocamlc
CAMLOPT = ocamlfind ocamlopt
LEXERGEN = ocamllex
PARSERGEN = ocamlyacc

#COMPILER = $(CAMLC) $(MLFLAGS) $(GTK_FLAGS) $(PXP_FLAGS) -c
#LINKER   = $(CAMLC) $(MLFLAGS) $(PXP_FLAGS) -linkpkg

COMPILER = $(CAMLC) $(MLFLAGS) $(PXP_FLAGS) -c
LINKER   = $(CAMLC) $(MLFLAGS) $(PXP_FLAGS) -linkpkg
MKTOP    = ocamlfind ocamlmktop $(PXP_FLAGS) -g -linkpkg

#CAMLOBJS=unix.cma threads.cma gtk.cma
#CAMLMKTOP = ocamlmktop -g 

GTKTEST_OBJS=gtktest.cmo  utils.cmo parse.cmo

OBJECTS_DIR=../objects

%.ml: %.xml
	$(GLADECC) $< > $@

%.cmi: %.mli
	$(COMPILER) $<

%.cmo: %.ml
	$(COMPILER) $<

%.ml: %.mll
	$(LEXERGEN) $<

%.ml: %.mly
	$(PARSERGEN) $<