(* ------------------------------------------------------------------------ *)
(* Entrypoint of the code                                                   *)

let main() =
  let files = ref [] in
  Arg.parse [] (fun x -> files := x :: !files) "
    usage: parse file ...

    ";
  match (!files) with
  | [] -> ()
  | (filename::_) ->
      print_string ("Reading " ^ filename ^ "\n");
      let svg = Xmlread.parse_svg_file filename in
      print_string "Parsed SVG. Generating Smoke data.\n";
      let smoke = Svgtosmoke.generate_smoke_scene svg in
      print_string "Smoke data generated. Outputting.\n";
      Smokewrite.write smoke;
      print_string "Done.\n"


(* This top level binding causes the program to be executed                 *)
let _ = main() 

