
(* Pretty-printer to test the path-data lexer *)

open Pathparse

let pp_token_verbose = function
  | NUMBER x -> string_of_float x

  | MOVE -> "MOVE"
  | MOVEREL -> "MOVEREL" 
  | CLOSE -> "CLOSE"
  | CLOSEREL -> "CLOSEREL"
  | LINE -> "LINE"
  | LINEREL -> "LINEREL"
  | HORIZLINE -> "HORIZLINE"
  | HORIZLINEREL -> "HORIZLINEREL"
  | VERTLINE -> "VERTLINE"
  | VERTLINEREL -> "VERTLINEREL"
  | CURVE -> "CURVE"
  | CURVEREL -> "CURVEREL"
  | SHORTHANDCURVE -> "SHORTHANDCURVE"
  | SHORTHANDCURVEREL -> "SHORTHANDCURVEREL"
  | QUADCURVE -> "QUADCURVE"
  | QUADCURVEREL -> "QUADCURVEREL"
  | SHORTHANDQUADCURVE -> "SHORTHANDQUADCURVE"
  | SHORTHANDQUADCURVEREL -> "SHORTHANDQUADCURVEREL"
  | ARC -> "ARC"
  | ARCREL -> "ARCREL"
  | EOF -> raise Pathlex.Eof


let _ =
  try
    let lexbuf = Lexing.from_channel stdin in

    while true do
      let t = Pathlex.token lexbuf in
      print_string ( (pp_token_verbose t) ^ "\n" )
    done
    

  with Pathlex.Eof ->
    exit 0
