/** file: editing.h
 */
/*
    Smoke Vector Graphics engine
    Copyright (C) 1998-2003  Jon Harrop

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef EDITING_H
#define EDITING_H

#include <list>



/** List class with the subset of the STL list interface which can be
 *  intercepted to catch all alterations to the list.
 */
template<class T>
class EditableList : private std::list<T>
{
 private:

 protected:

 public:
  /** Iterator type which does not provide public mutable dereferences. */
  class iterator : public std::list<T>::iterator
    {
    private:
      T &
	operator*();
      
      T *
	operator->();

    public:
      const T &
	operator*();
      
      const T *
	operator->();
    };
};



#endif /* EDITING_H */
