/** file: gldisplaylist.h
 */
/*
    Smoke Vector Graphics engine
    Copyright (C) 1998-2003  Jon Harrop

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef GLDISPLAYLIST_H
#define GLDISPLAYLIST_H

#include <GL/gl.h>



/** Encapsulation of an OpenGL display list.
 *
 *  Checks the initialisation of a display list and allows compilation and
 *  execution of the list.
 */
class GLDisplayList
{
 private:
  GLuint display_list;

 public:
  GLDisplayList();

  ~GLDisplayList();

  void
    begin();

  void
    end();

  void
    exec() const;
};



#endif /* GLDISPLAYLIST_H */
