/** file: tesselate.h
 */
/*
    Smoke Vector Graphics engine
    Copyright (C) 1998-2003  Jon Harrop

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef TESSELATE_H
#define TESSELATE_H

#include "vecmat.h"

#include <list>
#include <vector>
#include <GL/gl.h>
#include <GL/glu.h>

void
error_callback(GLenum err);

void
combine_callback(GLdouble coords[3],
		 char *vertex_data[4],
		 GLfloat weight[4],
		 GLdouble **data);

void
newTesselator(const GLenum winding_rule);

void
deleteTesselator();

void
tesselateContour(std::list<TinyVector<double, 3> > &coords,
		 std::list<std::vector<char> > &vertex_data,
		 const std::list<Vec> &contour);

void
renderTesselation(const std::list<std::list<Vec> > &polygon,
		  GLenum winding_rule);

#endif /* TESSELATE_H */
